"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseClient = void 0;
const eventemitter3_1 = require("eventemitter3");
const axios_1 = __importDefault(require("axios"));
const https_1 = __importDefault(require("https"));
const Constants_1 = require("../utils/Constants");
/**
 * Base Client for the Client to extend
 */
class BaseClient extends eventemitter3_1.EventEmitter {
    constructor(options = {}, payload = {}) {
        var _a, _b, _c, _d;
        super();
        this._payload = {};
        this._basic = "";
        this._bearer = null;
        // Set defaults
        let headers = (_a = options === null || options === void 0 ? void 0 : options.headers) !== null && _a !== void 0 ? _a : Constants_1.DefaultHeaders;
        headers["user-agent"] = (_b = options === null || options === void 0 ? void 0 : options.userAgent) !== null && _b !== void 0 ? _b : Constants_1.DefaultUserAgent;
        this.instance = axios_1.default.create({
            baseURL: `https://${Constants_1.APIBase}/${Constants_1.APIVersion}`,
            headers: headers,
            httpsAgent: new https_1.default.Agent({ keepAlive: true }),
        });
        this._payload = Object.assign({}, payload);
        this.clientId = (_c = options === null || options === void 0 ? void 0 : options.clientId) !== null && _c !== void 0 ? _c : Constants_1.DefaultClientId;
        this.clientSecret = (_d = options === null || options === void 0 ? void 0 : options.clientSecret) !== null && _d !== void 0 ? _d : Constants_1.DefaultClientSecret;
    }
    /**
     * Gets the payload
     */
    get payload() {
        return this._payload;
    }
    set payload(value) {
        this._payload = Object.assign(this.payload, value);
    }
    /**
     * Calls eval with the client set as the "this" context.
     * @param script The script to evaluate
     * @returns The result of the script
     */
    _eval(script) {
        return eval(script);
    }
}
exports.BaseClient = BaseClient;
//# sourceMappingURL=BaseClient.js.map