import { ErrorCodes } from "./ErrorCodes";
type MessageFunction = (...args: any[]) => string;

export const Messages = {
	[ErrorCodes.ClientNotLoggedIn]: (action: string) =>
		`The client needs to be logged in to ${action}.`,
	[ErrorCodes.InvalidBearerToken]: "An invalid bearer token was provided.",
	[ErrorCodes.InvalidBasicToken]: "An invalid basic token was provided.",
	[ErrorCodes.CaptchaRequired]:
		"A captcha is required. `error.captcha_url` contains the url to the captcha.",
	[ErrorCodes.InvalidGrant]: (description: string) => `Invalid grant: ${description}`,
	[ErrorCodes.UnknownError]: (error: any) => `An unknown error occurred: ${error}`,
};

export default Messages;
